import java.awt.*;

class Afficheur extends Canvas
{
    Font font;
    Comparable [] data;
    int numberOfData;
    Color[] colorMask;
    
    boolean otherCompare=false;  // en cas de compare mixte
    int otherCompareOffset;  
    int otherComparePosition;
    Comparable  otherComparable;
    
    
    boolean [] definitives;
    static Color backColor = Color.gray;
    static Color swapColor = Color.red;
    static Color compColor = Color.orange;
    static Color accessColor = Color.blue;
    static Color normalColor = Color.black;
    static Color definitiveColor = new Color(255,0,255);
    
    Afficheur(Font font, Comparable [] initialData) {
	this.font = font;
	setBackground(backColor);
	numberOfData = initialData.length;
	colorMask=new Color[numberOfData];
	definitives = new boolean[numberOfData];
	for(int i = 0;i < numberOfData ; i++)
	    definitives[i]=false;
	data = initialData;
	setVisible(true);
    }
    
    
    
    protected void colorReset() {
	for(int i = 0 ; i < numberOfData ; i++)
	    colorMask[i]=definitives[i]? definitiveColor:normalColor;
    }
    
    protected void definitif(int i) {
	definitives[i]=true;
    }
    
    protected void vizuSwap(Comparable [] data, int i, int j) {
	colorReset();
	this.data = data;
	colorMask[i]=colorMask[j]=swapColor;
	repaint();
    }
    
    
    protected void vizuCompare(Comparable [] data, int i, int j) {
	colorReset();
	this.data=data;
	colorMask[i]=colorMask[j]=compColor;
	repaint();
    }
    
    
    
    protected void vizuCompare(Comparable [] data, int i, Comparable y) {
	vizuCompare(data,y,i);
    }
    
    
    protected void vizuCompare(Comparable [] data, Comparable x, int j) {
	colorReset();
	this.data=data;
	otherCompare=true;
	otherComparePosition=j;
	otherComparable=x;
	colorMask[j]=compColor;
	repaint();
    }
    
    
    protected void vizuAccess(Comparable [] data,  int i) {
	colorReset();
	this.data=data;
	colorMask[i]=accessColor;
	repaint();
    }
    
    protected void vizu(Comparable [] data) {
	colorReset();
	this.data=data;
	repaint();
    }
    
    
    
    public void paint(Graphics g) {
	
    g.setFont(font);
    g.clearRect(0,0,getSize().width, getSize().height);
    int offsetX;
    offsetX=font.getSize();
    for(int i = 0; i < data.length ; i++) {
	g.setColor(colorMask[i]);
	String ch = data[i]+ " ";
	g.drawString(ch,offsetX,font.getSize());
	if(otherCompare && (i == otherComparePosition))
	    otherCompareOffset = offsetX;
	offsetX += font.getSize() * ch.length();
    }
    // affichage de l'autre comparable
    if(otherCompare)
	{
	    g.setColor(compColor);
	    g.drawString(otherComparable.toString(),otherCompareOffset, 
			 3*font.getSize());
	    otherCompare=false;
	}
    }
    
}


