#include <stdio.h>
#include <stdlib.h>
#include "pascal.h"

struct triangle {
  int limite;
  long **cases;
};

static void  remplir_ligne(triangle, int );
static void extension(triangle,int);

triangle new_triangle(int lim) {
  long ** cases =  malloc ((lim + 1) * sizeof(long *));
  triangle tr =  malloc (sizeof (struct triangle));
  int i;
  for(i=0;i<= lim ; i++)
    cases[i] =  malloc((i+1) * sizeof(long ));
  tr->limite = lim;
  tr->cases = cases;
  return tr;
}


void extension( triangle tr,int new_limit) {
  /* on suppose qu'on fait VRAIMENT une extension */
  int i;
  int new_size = new_limit+1;
  int old_limit = tr->limite;
  long ** new_cases = 
           realloc(tr->cases, new_size*sizeof(long *));  
  tr->limite = new_limit;
  tr->cases=new_cases;
  for(i=old_limit+1 ; i < new_size ; i++) {
   new_cases[i] =  malloc((i+1) * sizeof(long ));
    remplir_ligne(tr,i);
  }
}


void  liberez_le_triangle(triangle tr) {
  
  int i;
  for(i=0;i<=tr->limite;i++)
    free(tr->cases[i]);
  free(tr);
}



void triangle_afficher(triangle tr){
    int i;
    int j;
    for(i=0; i<= tr->limite; i++)
      {
	for(j=0;j<=i;j++) 
	  printf("%d ",tr->cases[i][j]);
	printf("\n");
      }
}

static void  remplir_ligne(triangle tr, int i)   {
      int j;
      tr->cases[i][0]=1;
      tr->cases[i][i]=1;
      for(j=1;j<i;j++)
	tr->cases[i][j] = tr->cases[i-1][j-1]+ tr->cases[i-1][j];
}


void triangle_remplir(triangle tr) {
  int i;
  int j;
  tr->cases[0][0]=1;
  for(i=1; i<= tr->limite; i++)
    remplir_ligne(tr,i);
}



int triangle_check(triangle tr) {
  int i;
  int j;
  long puis2 = 1;

  for(i=1;i<tr->limite;i++) 
    {
      long somme = 0;
      for(j=0;j<=i;j++)
	somme += tr->cases[i][j];
      if (somme != 2*puis2)
	return 0 ;
      puis2 = somme ;
    }
  return 1;
}


long binomial(triangle tr, int i, int j) {
if ( j < 0 || j > i )
     return 0;
     else  if (i > tr->limite )
     extension(tr,i);
     return tr->cases[i][j];
}






    
