#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "monoid.h"
#include "complex.h"

static monoid cmono_ref = NULL;

struct complex
{
  double re;
  double im;
};

complex
complex_new(double re, double im) 
{
  complex z = malloc(sizeof(struct complex));
  z->re = re;
  z->im = im;
  return z;
}

static void*
cunity()
{
  return complex_new(1.0,0.0);
}

static void*
cclone(void* z)
{
  return complex_new(((complex)z)->re,((complex)z)->im);
}

static void
cdelete(void* z)
{
  free((complex)z);
}


static void*
cmult(void* z1,void* z2)
{
  return complex_new(((complex)z1)->re * ((complex)z2)->re 
		     - ((complex)z1)->im * ((complex)z2)->im,
		     ((complex)z1)->re * ((complex)z2)->im 
		     + ((complex)z1)->im * ((complex)z2)->re);
}

static void*
csqr(void* z)
{
  return complex_new(((complex)z)->re * ((complex)z)->re 
		     - ((complex)z)->im * ((complex)z)->im,
		     2*((complex)z)->re * ((complex)z)->im);
}

  
void
cprintf(FILE *str,complex z)
{
  fprintf(str,"(%.2f +i*%.2f)\n",z->re,z->im);
}

monoid
the_cmonoid(void)
{
  if(cmono_ref == NULL)
    cmono_ref =  monoid_new(cunity,cmult,csqr,cclone,cdelete);
  return cmono_ref;
}



void
free_cmonoid(void)
{
  if (cmono_ref != NULL)
   {
     free_monoid(cmono_ref);
     cmono_ref = NULL;
   }
}
