#include <stdlib.h> 
#include <stdio.h>

#include "monoid.h"
#include "matrix.h"
static monoid matmono_ref = NULL;

struct matrix
{
  double a11;
  double a12;
  double a21;
  double a22;
};


matrix
new_matrix(double a,double b, double c, double d)
{
  matrix m = malloc(sizeof (struct matrix));
  m -> a11 = a;
  m -> a12 = b;
  m -> a21 = c;
  m -> a22 = d;
  return m;
}


static void*
unity_matrix(void)
{
  return new_matrix(1.0,0.0,0.0,1.0);
}

static void*
matrix_mult(void *m1,void *m2)
{
  return new_matrix(((matrix)m1)->a11*((matrix)m2)->a11
		    +((matrix)m1)->a12*((matrix)m2)->a21,
		    ((matrix)m1)->a11*((matrix)m2)->a12
		    +((matrix)m1)->a12*((matrix)m2)->a22,
		    ((matrix)m1)->a21*((matrix)m2)->a11
		    +((matrix)m1)->a22*((matrix)m2)->a21,
		    ((matrix)m1)->a21*((matrix)m2)->a12
		    +((matrix)m1)->a22*((matrix)m2)->a22);
}

static void*
matrix_sqr(void* m)
{
  return matrix_mult(m,m);
}

static void
matrix_free(void *m)
{
  free((matrix)m);
}

static void*
matrix_clone(void *m)
{
  return new_matrix(((matrix)m)->a11,((matrix)m)->a12,
		    ((matrix)m)->a21,((matrix)m)->a22);
}

monoid
the_matmonoid(void)
{
  if(matmono_ref == NULL)
    matmono_ref =  monoid_new(unity_matrix,matrix_mult,matrix_sqr,
			      matrix_clone,matrix_free);
  return matmono_ref;
}

void
free_matmonoid(void)
{
  if (matmono_ref != NULL)
   {
     free_monoid(matmono_ref);
     matmono_ref = NULL;
   }
}



void
matrix_fprintf(FILE *str,matrix m)
{
  fprintf(str,"\n[%.2f,%.2f]\n[%.2f,%.2f]",m->a11,m->a12,
	  m->a21,m->a22);
}





