/* we don't benefit from the conversion between pointers and integers */
#include <stdlib.h>

#include "monoid.h"
#include "integer.h"

static monoid integer_monoid_ref = NULL;

struct integer
{
  int value;
};

integer
integer_new(int v)
{
  integer tmp = malloc(sizeof(struct integer));
  tmp -> value = v;
  return tmp;
}

int
integer2i(integer i)
{
  return i -> value;
}


static void *
integer_one(void)
{
  return integer_new(1);
}

static void*
integer_mult(void *a,void *b)
{
  int v1 = integer2i((integer)a);
  int v2 = integer2i((integer)b);
  return  (void *)(integer_new(v1 * v2));
}

static void*
integer_sqr(void *a)
{
  int v = integer2i((integer)a);
  return (void *)(integer_new(v * v));
}

static void
integer_free(void *o)
{
  free((integer)o);
}

static void*
integer_clone(void *o)
{
  int v = integer2i((integer)o);
  return (void *)(integer_new(v));
}



monoid
the_integer_monoid(void)
{
  if(integer_monoid_ref == NULL)
    integer_monoid_ref =  monoid_new(integer_one,
				     integer_mult,
				     integer_sqr,
				     integer_clone,
				     integer_free);
  return integer_monoid_ref;
}

void 
free_integer_monoid(void)
{
  if (integer_monoid_ref != NULL)
   {
     free_monoid(integer_monoid_ref);
     integer_monoid_ref = NULL;
   }
}

