/* (c) P. Casteran 
*/


#include <stdlib.h>
#include <assert.h>
#include "monoid.h"
#include "monoid_elt.h"


struct monoid_elt
{
  monoid origin;
  void *value;
};


monoid_elt
monoid_elt_box(monoid m, void *v)
{
  monoid_elt e;
  assert(m != NULL);
  e = malloc(sizeof(struct monoid_elt));
  e->origin = m;
  e->value = v;
}


void *
monoid_elt_unbox(monoid_elt e)
{
  return e -> value;
}


monoid
monoid_elt_get_origin(monoid_elt e)
{
  return e->origin;
}


monoid_elt
monoid_elt_clone(monoid_elt e)
{
  monoid m  = e->origin;
  monoid_unary fun ;
  assert(m != NULL);
  fun = monoid_get_clone(m);
  return monoid_elt_box(m, (*fun)(e->value));
}

void 
monoid_elt_free(monoid_elt e)
{
  monoid m = e ->origin;
  monoid_side_effect fun;
  assert(m != NULL);
  fun = monoid_get_delete(m);
  (*fun)(e->value);
  free(e);
}


monoid_elt
monoid_elt_unity(monoid m)
{
  assert(m != NULL);
  return monoid_elt_box(m,(*(monoid_get_unity(m)))());
}


monoid_elt
monoid_elt_mult(monoid_elt a, monoid_elt b)
{
  monoid m = monoid_elt_get_origin(a);
  assert(m != NULL);
  assert(m == monoid_elt_get_origin(b));
  return monoid_elt_box(m, (*(monoid_get_mult(m)))(monoid_elt_unbox(a),
						   monoid_elt_unbox(b)));
}


monoid_elt
monoid_elt_sqr(monoid_elt a)
{
  monoid m = monoid_elt_get_origin(a);
  assert(m != NULL);
  return monoid_elt_box(m, (*(monoid_get_sqr(m)))(monoid_elt_unbox(a)));
}



