/* monoid elements

 (c) P. Casteran

*/

#ifndef INC_MONOID_ELT
#define INC_MONOID_ELT

#include "monoid.h"

typedef struct monoid_elt *monoid_elt;


/* constructors */
/****************/

/*  transforms some value into a monoid element */
extern monoid_elt monoid_elt_box(monoid m,void *v);

extern monoid_elt monoid_elt_unity(monoid m);
extern monoid_elt monoid_elt_clone(monoid_elt e);


/* selectors */
/*************/

extern void *monoid_elt_unbox(monoid_elt e);
extern monoid monoid_elt_get_origin(monoid_elt e);


/* operations */
/**************/

extern monoid_elt monoid_elt_mult(monoid_elt,monoid_elt);
extern monoid_elt monoid_elt_sqr(monoid_elt);			 


/* destructor */
/**************/
extern void monoid_elt_free(monoid_elt e);




#endif /*  INC_MONOID_ELT */

