/** permet de trier des valeurs "comparables" et de tracer ou non les
    oprations lmentaires (comparaisons, changes, accs) */

abstract class Sort {
 
    private Comparable[] data ;
    
    protected abstract void doSort() throws NotComparableException;
    
    private Tracer tracer = new TracerLambda();
    

    public  void setTracer(Tracer t) {
	if (t != null)
	    tracer = t;
	else
	    System.err.println("setTracer  : changement non effectu");
    }

    public final void sort (Comparable[] items) {
	data = items;
	tracer.showValues(data);
	try {doSort(); }
	catch (NotComparableException e) {
	    System.err.println(e.getMessage());
	    System.err.println("je ne touche plus au tableau ");
	    return;}
	finally {
	    tracer.finish(data);
	}
    }
    
    protected final int dataLength() {
	return data.length;
    }
    
    
    // basic methods
    
    protected final int compare(int i, int j)
	throws NotComparableException {
	tracer.traceCompare(data,i,j);
	Comparable d1 = data [i];
	Comparable d2 = data [j];
	return d1.comp(d2);
    }
    
    protected final int compare(Comparable x, int j)
	throws NotComparableException{
	tracer.traceCompare(data,x,j);
	Comparable d2 = data [j];
	return x.comp(d2);
    }
    
    protected final int compare(int i, Comparable y) 
	throws NotComparableException{
	tracer.traceCompare(data,i,y);
	Comparable d1 = data [i];
	return d1.comp(y);
    }
    
    
    protected final void swap(int i, int j) {
	tracer.traceSwap(data,i,j);
	Comparable tmp = data[i];
	data[i]=data[j];
	data[j]=tmp;
    }
    
    protected final Comparable access(int i) {
	tracer.traceAccess(data,i); 
	return data[i] ;
    }
    


    protected final void definitif(int i)
    {
	tracer.definitif(i);
    }

}









