/* polymorphic monoids */
/*                    */
/* (c) P. Casteran */


#ifndef INC_MONOID
#define INC_MONOID

typedef struct monoid *monoid;
typedef void *(*monoid_const)(void);
typedef void *(*monoid_unary)(void *arg);
typedef void *(*monoid_binary)(void *arg1, void *arg2);
typedef void (*monoid_side_effect)();

/* constructors */
/****************/

extern monoid monoid_new(monoid_const unity,    /* unity builder */
			 monoid_binary mult,    /* product */
			 monoid_unary sqr,      /* squaring */
			 monoid_unary clone,
			 monoid_side_effect delete);

/* selectors */
/*************/

extern monoid_const monoid_get_unity(monoid m);
extern monoid_unary monoid_get_sqr(monoid m);
extern monoid_binary monoid_get_mult(monoid m);
extern monoid_unary monoid_get_clone(monoid m);
extern monoid_side_effect monoid_get_delete(monoid m);

/* destructor */
/**************/

extern void monoid_free(monoid m);

#endif /* INC_MONOID */

