#include <stdlib.h> 
#include <stdio.h>


#include "monoid.h"
#include "vectors.h"
static monoid vmono_ref = NULL;

struct vector
{
  double dx;
  double dy;
};


vector
new_vector(double a,double b)
{
  vector v = malloc(sizeof (struct vector));
  v -> dx = a;
  v -> dy = b;
  return v;
}


static void*
null_vector(void)
{
  return new_vector(0.0,0.0);
}

static void*
somme_vector(void *u,void *v)
{
  return new_vector(((vector)u)->dx + ((vector)v)->dx,
		    ((vector)u)->dy + ((vector)v)->dy);
}

static void*
v_sqr(void* u)
{
  return somme_vector(u,u);
}

static void
v_free(void *u)
{
  free((vector)u);
}

static void*
v_clone(void *u)
{
  return new_vector(((vector)u)->dx,((vector)u)->dy);
}



monoid
the_vmonoid(void)
{
  if(vmono_ref == NULL)
    vmono_ref =  monoid_new(null_vector,somme_vector,v_sqr,v_clone,v_free);
  return vmono_ref;
}

void
free_vmonoid(void)
{
  if (vmono_ref != NULL)
   {
     free_monoid(vmono_ref);
     vmono_ref = NULL;
   }
}



void
vector_fprintf(FILE *str,vector v)
{
  fprintf(str,"(%f,%f)",v->dx,v->dy);
}





